=== debian/changelog ===
superlu (7.0.0+dfsg1-2) unstable; urgency=medium

  * Upload to unstable. Transition #1082552.

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Oct 2024 10:42:41 +0200

superlu (7.0.0+dfsg1-1exp1) experimental; urgency=medium

  * New upstream release. New ABI 7.
  * configure build with CMAKE_SKIP_INSTALL_RPATH=ON
    instead of CMAKE_SKIP_RPATH. superlu 7 needs the built-time
    runpath in tests to find libmatgen.so in TESTING/MATGEN
    (regression from superlu 6, see upstream Issue#153, but
    CMAKE_SKIP_INSTALL_RPATH is more appropriate for eliminating
    RUNPATH from final installed libraries anyway)
  * debian/tests: explicit build tests before running ctest
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Sun, 01 Sep 2024 16:38:46 +0200
